Subject: Re: 2.4.30-hf1 do_IRQ stack overflows

From: Marcelo Tosatti <[email-masked]>
Date: Wed, 11 May 2005 09:46:40 -0300

Hi Manfred,

On Wed, May 11, 2005 at 10:15:02AM +0200, Manfred Schwarb wrote:
> Hi,
> with recent versions of the 2.4 kernel (Vanilla), I get an increasing amount of do_IRQ stack overflows.
> This night, I got 3 of them.
> With 2.4.28 I got an overflow about twice a year, with 2.4.29 nearly once a month and with
> 2.4.30 nearly every day 8-((

The system is getting dangerously close to an actual stack overflow, which would 
crash the system. 

"do_IRQ: stack overflow: " indicates how many bytes are still available. 

The traces show huge networking execution paths.

It seems you are using some packet scheduler (CONFIG_NET_SCHED)? Pretty much all 
traces show functions from sch_generic.c. Can you disable that for a test? 

> My layout: Pentium4 HT SMP, raid1 on a promise card, driven by libata_promise, 
> everything using reiserfs, heavy nfs and network traffic, with a Linksys (tulip) and a Realtek (8139too) NIC.
> The used 2.4.30-hf1 is pure Vanilla.
> 
> Below my three overflow messages. Would the stack reduction patches of Badari Pulavarty
> help in my case? If so, I would strongly vote for inclusion into 2.4 series!!

It has been decided that the stack reduction patches were too intrusive to be merged
at this stage of v2.4 life. 

We did not receive any report either - v2.4's 8KB kernel stack seems to be enough
for vast majority of situations.